const
  GgtExt = '.ggt';

var
  GgtDirLib: string;
  tagCountLib: string;
  tagDistanceLib: string;
  ignoreListLib: string;
  useFinalLocationLib: string;


procedure cleanEnv;
begin
  DeleteFiles(Geoget_ScriptDir + GgtDirLib + '*' );
end;

procedure setupEnv(GgtDirScript, tagCountScript, tagDistanceScript, ignoreListScript, useFinalLocationScript: String);
begin
  { priradit hodnoty }
  useFinalLocationLib := useFinalLocationScript;
  GgtDirLib           := GgtDirScript;
  tagCountLib         := tagCountScript;
  tagDistanceLib      := tagDistanceScript;
  ignoreListLib       := ignoreListScript;
  useFinalLocationLib := useFinalLocationScript;

  { vytvorit TEMP adresar }
  if not DirectoryExists( Geoget_ScriptDir + GgtDirLib ) then
  begin
    ForceDirectories(Geoget_ScriptDir + GgtDirLib );
  end
  else
  begin
    cleanEnv;
  end;
end;

procedure countDistance(CahceList: TStringList; tagC, tagD: string); //: TStringList;
var
  ResCount,ResDistance: string;
  Distance: extended;
  i: Integer;
  cache1,Cache2: TGeo;
begin
  Cache1 := TGeo.create();
  Cache2 := TGeo.Create();

  { pocet zpracovanych kesek}
  ResCount := IntToStr(CahceList.Count);
  { pocitani vzdalenosti }
  Distance := 0;
  for i := 0 to CahceList.Count-2 do
  begin
    Cache1.LoadByGC(CahceList[i]);
    Cache2.LoadByGC(CahceList[i+1]);
    { pouzit CorrectedLat CorrectedLon nebo LatNum LonNum }
    if (useFinalLocationLib = '0') then
    begin
      Distance := Distance + PointDistance(Cache1.LatNum, Cache1.LonNum, Cache2.LatNum, Cache2.LonNum);
    end
    else
    begin
      Distance := Distance + PointDistance(Cache1.CorrectedLatNum, Cache1.CorrectedLonNum, Cache2.CorrectedLatNum, Cache2.CorrectedLonNum);
    end;
  end;
  ResDistance := FormatFloat('#0',Distance * 100.0);
  Cache1.Free();
  Cache2.Free();

  { zapsani tagu do kesky }
  for i:=0 to CahceList.Count-1 do
  begin
    Cache1:=TGeo.Create(); // viz TagManipulate v Combine.lib.pas
    Cache1.id:=CahceList[i]; // podle Gebyho staci jen priradit ID
    if(Cache1.id<>'') then
    begin
      if Cache1.TagHaveCategory(AnsiToUtf(tagC)) then
      begin
        Cache1.TagReplace(AnsiToUtf(tagC),AnsiToUtf(ResCount));
      end
      else
      begin
        Cache1.TagAdd(AnsiToUtf(tagC),AnsiToUtf(ResCount));
      end;
      if Cache1.TagHaveCategory(AnsiToUtf(tagD)) then
      begin
        Cache1.TagReplace(AnsiToUtf(tagD),AnsiToUtf(ResDistance));
      end
      else
      begin
        Cache1.TagAdd(AnsiToUtf(tagD),AnsiToUtf(ResDistance));
      end;
    end;
    Cache1.Free();
  end;

  //ShowMessage(ResDistance);

end;

procedure generateDayDistanceGgt;
var
  tab: TSqliteTable;
  sqlCount,sqlProc,sql1,sql2,whereString: string;
  CachesToProcess,Counter: integer;
begin

  { nadefinul SQL }
  whereString := '';
  if ( ignoreListLib <> '' ) then
  begin
    whereString := ' and id not in (''' + ReplaceString(ReplaceString(ignoreListLib, ' ', ''), ',', ''',''') + ''') ';
  end;

  sql1 := 'SELECT group_concat( id, x''0d0a'' ) content, dtfound, count(*) count FROM (select id, dtfound, dtfoundtime from geocache where dtfound > 0 and dtfoundtime > 0 and x <> ''0'' and y <> ''0'' ';
  sql2 := ' order by dtfoundtime asc ) group by dtfound having count(*) > 1';

  sqlProc := sql1 + whereString + sql2;
  sqlCount := 'SELECT count(*) from ( ' + sqlProc + ' )';

  Counter := 0;
  CachesToProcess := Geoget_DB.GetTableValue(sqlCount);

  GeoBusyProgress(Counter , CachesToProcess);
  GeoBusyCaption('Distance');
  GeoBusyKind('Generating gtt files...');

  tab := Geoget_DB.GetTable(sqlProc, false);
  try
    while not tab.eof do
    begin
      { posun counter }
      Counter := Counter + 1;
      GeoBusyProgress(Counter , CachesToProcess);
      { ulozit vybenerovany ggt}
      StringToFile(tab.FieldAsString(tab.FieldIndex['content']), Geoget_ScriptDir + GgtDirLib + tab.FieldAsString(tab.FieldIndex['dtfound']) + GgtExt);
      tab.next;
    end;
  finally
    tab.free;
  end;
end;

procedure processGgt;
var
  listGgt,CahceList: TStringList;
  i: Integer;
  Counter,CachesToProcess: Integer;
begin
  if not GeoBusyTest then
  begin
    { pro kazdy soubor v adresari }
    listGgt := TStringList.Create();
    FileList(Geoget_ScriptDir + GgtDirLib, listGgt);
  
    Counter := 0;
    CachesToProcess := listGgt.Count;
    GeoBusyProgress(Counter , CachesToProcess);
    GeoBusyCaption('Distance');
    GeoBusyKind('Counting distance..');

    { zpracovani }
    for i := 0 to listGgt.Count-1 do
    begin
      Counter := Counter + 1;
      GeoBusyProgress(Counter , CachesToProcess);
      CahceList:=TStringList.Create;
      CahceList.LoadFromFile(listGgt[i]);
      { volani s parametrem - priprava na volani pro ruzne tagy a seznamy kesi }
      countDistance(CahceList, tagCountLib, tagDistanceLib);
    end;
  end;
end;
